---
title: Add Delivery Option association with Exclusion Lists
slug: api-documentation/add-delivery-option-association-with-exclusion-lists
docTags: 
createdAt: 2026-08-27T16:55:41.659Z
---

{
  "id": "1VANi8dBpcfwGdTG3wnqh",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-delivery-option-exclusion-list",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-delivery-option-exclusion-list"
      }
    ],
    "name": "Add Delivery Option association with Exclusion Lists",
    "description": "<p>This endpoint is used to associate a delivery option with product exclusion lists for DMC.</p>\n<p>Authorized permissions:</p>\n<ul>\n<li><code>dmc-shipping-calc.create</code></li>\n<li><code>dmc-shipping-calc.update</code></li>\n</ul>\n<p>Authorized roles:</p>\n<ul>\n<li>service.operator</li>\n<li>operator.default</li>\n</ul>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "kind": "required",
          "name": "x-upstart-tenant",
          "type": "string",
          "description": "Tenant identifier associated with the site this call is for."
        },
        {
          "kind": "optional",
          "name": "x-upstart-site",
          "type": "string",
          "description": "Unique identifier for the site."
        }
      ],
      "queryParameters": [
        {
          "kind": "optional",
          "name": "deliveryOption",
          "type": "string",
          "description": "The delivery option of the stored record which is to be updated."
        }
      ],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "array",
          "description": "",
          "minItems": 1,
          "uniqueItems": true,
          "customType": "CreateDeliveryOptionExclusionList[]",
          "schema": [
            {
              "name": "siteIds",
              "kind": "required",
              "type": "array",
              "description": "Site identifiers for which this association is provided.",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            },
            {
              "name": "deliveryOption",
              "kind": "required",
              "type": "string",
              "description": "Delivery option against which the exclusion lists are associated.",
              "minLength": 1
            },
            {
              "name": "exclusionListIds",
              "kind": "required",
              "type": "array",
              "description": "Exclusion list identifiers.",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            },
            {
              "name": "isActive",
              "kind": "optional",
              "type": "boolean",
              "description": "A flag that tells whether this association is active or not."
            }
          ],
          "modelRef": "#/components/schemas/CreateDeliveryOptionExclusionList",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "NoChannelPortalAccess",
          "name": "NoChannelPortalAccess",
          "kind": "optional",
          "type": "http",
          "description": "<p>This authentication is required for clients to interact with any of the management APIs. Similar to 'LoggedIn', it indicates that the user has actually logged into the system, but in this case with a management role.</p>",
          "scheme": "bearer"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "<p>OK-the associations are added successfully.</p>",
        "jsonExample": "",
        "isExpanded": true
      },
      {
        "statusCode": "400",
        "description": "The request contained information that the server was unable to process. Appropriate errors are provided in the response body.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ValidationErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ValidationErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "code",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "detail",
                "kind": "required",
                "type": "string",
                "description": ""
              },
              {
                "name": "reason",
                "kind": "optional",
                "type": "string",
                "description": ""
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "-f5OTQy0L0l-MjaPMa3q_",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-delivery-option-exclusion-list \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --header 'x-upstart-tenant: string' \\\n     --data '[\n     {\n     \"siteIds\": [],\n     \"deliveryOption\": \"\",\n     \"exclusionListIds\": []\n     }\n     ]'"
        },
        {
          "id": "opuMkglOAvE-N85y6_yte",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\nmyHeaders.append(\"x-upstart-tenant\", \"string\");\n\nvar raw = JSON.stringify([\n   {\n      \"siteIds\": [],\n      \"deliveryOption\": \"\",\n      \"exclusionListIds\": []\n   }\n]);\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-delivery-option-exclusion-list\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "G2RfT9BG35fwuyiDMVvnM",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-delivery-option-exclusion-list\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest[\"x-upstart-tenant\"] = \"string\"\nrequest.body = JSON.dump([\n   {\n      \"siteIds\": [],\n      \"deliveryOption\": \"\",\n      \"exclusionListIds\": []\n   }\n])\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "XpihtuqG1qOcDcmduyhQF",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/v1/dmcshippingcalc/dmc-delivery-option-exclusion-list\"\n\npayload = json.dumps([\n   {\n      \"siteIds\": [],\n      \"deliveryOption\": \"\",\n      \"exclusionListIds\": []\n   }\n])\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json',\n   'x-upstart-tenant': 'string'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "-f5OTQy0L0l-MjaPMa3q_"
    },
    "results": {
      "languages": [
        {
          "id": "obgu9MVTTX_yI0E9qG1LW",
          "language": "200",
          "code": "// OK-the associations are added successfully.\n"
        },
        {
          "id": "DPnn8H_VAcUdvl31XIm4-",
          "language": "400",
          "code": "// The request contained information that the server was unable to process. Appropriate errors are provided in the response body.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\"\n}"
        },
        {
          "id": "sU2hOyfziDlELWnpv5J42",
          "language": "401",
          "code": "// The provided credentials were not valid for this endpoint. It may be that they are expired or that the user's roles are insufficient.\n{\n  \"name\": \"\",\n  \"code\": \"\",\n  \"detail\": \"\",\n  \"reason\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "obgu9MVTTX_yI0E9qG1LW"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}